#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_queue4xi.py">
#<abstract4xi abstract = "tests queue4xi"/>
#<verify4xi verification = "10" target = "queue4xi.py"/>
#<contextualize4xi context = "arrayfunction4xi.py; lock4xi.py; manager4xi.py; pipe4xi.py; pool4xi.py; process4xi.py; queue4xi.py; value4xi.py"/>
#<use4xi usage = "
#
# RUN:
# > call t  test_queue4xi > ..\txt\test_queue4xi.txt <-- trace OF TEST_QUEUE4XI
#
# after testing:
# > call t test_noun4xi > ..\txt\test_noun4xi.txt <-- set ace-test-queue4xi.xml': 'nack' in test_noun4xi.py #
# 
# ANALYZE:
# sense-test-queue4xi.xml     <-- trace in XML
# reason-test-queue4xi.xml
# ace-test-queue4xi.xml
# test_queue4xi.txt           <-- textual trace
#
# after testing:
# scope-ace-test-queue4xi.xml <-- scope file (make sure test_noun4xi.py setting is ok)
#"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_queue4xi',
            'set_trace4xi',                        
            'print_trace4xi']
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import mmap
import os
import sys
import threading                
import _thread 
import _winapi  

from ctypes import Structure, c_double
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from arena4xi import Arena4Xi
from pipe4xi import Pipe4Xi
from queue4xi  import Queue4Xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "

    KB4Tailoring = {
        'Arena4Xi': 'NACK4TRACE',
        'Pipe4Xi':  'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        'assert_spawning4xi': 'NACK4TRACE',
        'BoundedSemaphore4Xi': 'NACK4TRACE',
        'Condition4Xi': 'NACK4TRACE',
        'ConstantSystem4Xi': 'NACK4TRACE',
        'get_windows_system4xi': 'NACK4TRACE',
        'get_sem_value_max_synchronize4xi': 'NACK4TRACE',
        'Finalize4Xi': 'NACK4TRACE',
        'is_exiting4xi': 'NACK4TRACE',
        'init_exiting4xi': 'NACK4TRACE',
        'set_exiting4xi': 'NACK4TRACE',
        'get_exiting4xi': 'NACK4TRACE',
        'Lock4Xi': 'NACK4TRACE',
        'PipeConnection4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       

  
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(p2xi):
  

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-queue4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Queue4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Queue4Xi.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-queue4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Queue4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Queue4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-queue4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Queue4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Queue4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
      

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-queue4xi" usage = "
#   testing queue4xi  
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def test_queue4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF TEST_QUEUE4XI - SET T2XI TO: ", t2xi)
    # 02:58:24 01/22/13 Pacific Standard Time 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:

        # -----------------------------------------------------------------------------------------
        # 
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 1/70) OF TEST_QUEUE4XI: STARTED ", time4xi())

        
        # -----------------------------------------------------------------------------------------
        # CREATE ARENA
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 1A/70) OF TEST_QUEUE4XI - TRYING TO CREATE AND USE ARENA4XI OBJECT", time4xi())   
        length2xi = 256     
        try:
            arena2xi = Arena4Xi(length2xi)
            print("(STEP 1B/70) OF TEST_QUEUE4XI - CREATED ARENA4XI  OBJECT: ", arena2xi) 
            print("(STEP 1C/70) OF TEST_QUEUE4XI - LENGTH OF ARENA: ", arena2xi.size)
            print("(STEP 1D/70) OF TEST_QUEUE4XI - NAME OF ARENA: ", arena2xi.name)

            buffer2xi = arena2xi.buffer
            print("(STEP 1E/70) OF TEST_QUEUE4XI - BUFFER OF ARENA: ", buffer2xi)
            print("(STEP 1F/70) OF TEST_QUEUE4XI - STATE OF ARENA: ", arena2xi._state)
            print("(STEP 1G/70) OF TEST_QUEUE4XI - COUNTER OF ARENA: ", Arena4Xi._counter)
            # LENGTH OF ARENA:  256
            # NAME OF ARENA:  pym-3616-0
            # BUFFER OF ARENA:  <mmap.mmap object at 0x00000000036CCC90>
            # STATE OF ARENA:  (256, 'pym-3616-0')
            # COUNTER OF ARENA:  count(1)

        except:
            print("(STEP 1Z/70) OF TEST_QUEUE4XI *** FAILED TO CREATE AND USE ARENA4XI OBJECT ", time4xi())
        

                  
        # -----------------------------------------------------------------------------------------
        # OPERATIONS WITH IMAGE 1 
        # -----------------------------------------------------------------------------------------         
        print("(STEP 2A/70) OF TEST_QUEUE4XI - TRYING IMAGE 1 ", time4xi())    
        try:        
            path1 = '..//..//..//..//web//images//png//1.png'
            file1 = open(path1)
 
            print("(STEP 2B1/70) OF TEST_QUEUE4XI - FILENO: ", file1.fileno( ))  
            print("(STEP 2B2/70) OF TEST_QUEUE4XI - MODE: ", file1.mode)
            print("(STEP 2B2/70) OF TEST_QUEUE4XI - NAME: ", file1.name)

            offset1 = 10
            file1.seek(offset1)
            print("(STEP 2B3/70) OF TEST_QUEUE4XI - PERFORMED SEEK WITH OFFSET: ", offset1)
            file1.close()
            print("(STEP 2B70/70) OF TEST_QUEUE4XI - CLOSED IMAGE FILE: ", path1)  
            # PERFORMED SEEK WITH OFFSET:  10
            # CLOSED IMAGE FILE:  ..//..//..//..//web//images//png//1.png
        except:
            print("(STEP 2Z/70) OF TEST_QUEUE4XI *** FAILED TO PERFORM FILE OPERATIONS WITH IMAGE 1: ", path1)
        
        # -----------------------------------------------------------------------------------------
        # IMAGE 2
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 3A/70) OF TEST_QUEUE4XI - TRYING TO OPEN FOR MEMORY MAP IMAGE 2 ", time4xi())   
        try:
            path2 = '..//..//..//..//web//images//png//2.png'
            file2 = open(path2)
            print("(STEP 3B1/70) OF TEST_QUEUE4XI - OPENED FILE: ", file2)  
            # 
            fileno2 = file2.fileno()
            print("(STEP 3B2/70) OF TEST_QUEUE4XI - FILENO: ", fileno2)  
            # TRYING TO OPEN FOR MEMORY MAP IMAGE 2  05:16:32 09/08/11 Pacific Daylight Time
            # OPENED FILE:  <_io.TextIOWrapper name='..//..//..//..//web//images//png//2.png' mode='r' encoding='cp1252'>
            # FILENO:            
        except:
            print("(STEP 3Z1/70) OF TEST_QUEUE4XI *** FAILED TO OPEN FOR MEMORY MAP IMAGE 2 ", time4xi())
        
        # -----------------------------------------------------------------------------------------
        # MEMORY MAP WITH IMAGE 2 - IMAGES NOT SUPPORTED - ONLY TEXT FILES !
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 4A/70) OF TEST_QUEUE4XI - TRYING TO MEMORY MAP IMAGE 2 ", time4xi())  
        # 02:58:24 01/22/13 Pacific Standard Time
        try:    
            map2 = mmap.mmap(fileno2, 0)                                             # fails also with fileno2                                                   
            print("(STEP 4B/70) OF TEST_QUEUE4XI - MAPPED IMAGE 2 ", map2)
            
            try:                
                map2.seek(0)
                print("(STEP 4C/70) OF TEST_QUEUE4XI - SEEKED MAP2 ", map2)
                
            except:
                map2.close()
                
        except:
            print("(STEP 4Z/70) OF TEST_QUEUE4XI *** FAILED TO MEMORY MAP IMAGE 2 ", time4xi()) 
            # *** FAILED TO MEMORY MAP IMAGE 2  02:58:24 01/22/13 Pacific Standard Time
            
        # -----------------------------------------------------------------------------------------
        # CREATE QUEUE 
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 5A/70) OF TEST_QUEUE4XI - TRYING TO CREATE QUEUE ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time
        try:    
            queue2xi = Queue4Xi()             
            print("(STEP 5B/70) OF TEST_QUEUE4XI - CREATED QUEUE ", queue2xi)
            # <queue4xi.Queue4Xi object at 0x0000000003690550>
        except:    
            print("(STEP 5Z/70) OF TEST_QUEUE4XI *** FAILED TO CREATE QUEUE ", time4xi()) 
            # 
            
        # -----------------------------------------------------------------------------------------
        # QUEUE STATISTICS 
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 5C/70) OF TEST_QUEUE4XI - QUEUE STATISTICS ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time
        try:
            print("(STEP 5D/70) OF TEST_QUEUE4XI - QUEUE SIZE: ", queue2xi.qsize())
            # 2147483646
            print("(STEP 5E/70) OF TEST_QUEUE4XI - QUEUE EMPTY: ", queue2xi.empty())
            # True
            print("(STEP 5F/70) OF TEST_QUEUE4XI - QUEUE FULL: ", queue2xi.full())
            # False      
        except:    
            print("(STEP 5Z/70) OF TEST_QUEUE4XI *** FAILED IN QUEUE STATISTICS ", time4xi()) 
         
        # -----------------------------------------------------------------------------------------
        # PUT IMAGE PATH2 TO QUEUE - OK
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 6A/70) OF TEST_QUEUE4XI - TRYING TO PUT IMAGE PATH2 TO QUEUE ", time4xi())     
        # 02:58:24 01/22/13 Pacific Standard Time
        try:    
            queue2xi.put(path2)             
            print("(STEP 6B/70) OF TEST_QUEUE4XI - PUT TO IMAGE PATH2 ", path2)
            # ..//..//..//..//web//images//png//2.png
        except:
            print("(STEP 6Z/70) OF TEST_QUEUE4XI *** FAILED TO PUT IMAGE PATH2 ", time4xi())
            # 
            
                        
        # -----------------------------------------------------------------------------------------
        # GET IMAGE PATH2 FROM QUEUE- OK 
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 7A/70) OF TEST_QUEUE4XI - TRYING TO GET IMAGE PATH2 ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time
        try:    
            pathfromqueue = queue2xi.get()             
            print("(STEP 7B/70) OF TEST_QUEUE4XI - GOT FROM QUEUE IMAGE PATH", pathfromqueue)
            # ..//..//..//..//web//images//png//2.png
        except:
            print("(STEP 7Z/70) OF TEST_QUEUE4XI *** FAILED TO IMAGE PATH2 FROM QUEUE ", time4xi())
            # 
            
                        
        # -----------------------------------------------------------------------------------------
        # CLOSE QUEUE- OK 
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 9C/70) OF TEST_QUEUE4XI - TRYING TO CLOSE QUEUE ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time
        try:    
            imageobject2queue = queue2xi.get()             
            print("(STEP 9B/70) OF TEST_QUEUE4XI - CLOSED QUEUE ", time4xi())
            # 02:58:24 01/22/13 Pacific Standard Time
        except:
            print("(STEP 9Z/70) OF TEST_QUEUE4XI *** FAILED TO CLOSE QUEUE ", time4xi())
            #        
         
        # -----------------------------------------------------------------------------------------
        # CREATE SECOND QUEUE- OK 
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 5A/70) OF TEST_QUEUE4XI - TRYING TO  CREATE SECOND QUEUE ", time4xi())  
        # 02:58:24 01/22/13 Pacific Standard Time
        try:    
            queue2messages = Queue4Xi()             
            print("(STEP 5B/70) OF TEST_QUEUE4XI - CREATED SECOND QUEUE ", queue2messages)
            # <queue4xi.Queue4Xi object at 0x000000000378E160>
        except:    
            print("(STEP 5Z/70) OF TEST_QUEUE4XI *** FAILED TO CREATE SECOND QUEUE ", time4xi()) 
                        
                        
        # -----------------------------------------------------------------------------------------
        # PUT TEXT MESSAGE TO QUEUE - OK 
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 10/70) OF TEST_QUEUE4XI - TRYING TO PUT TEXT MESSAGES TO QUEUE ", time4xi())    
        # 02:58:24 01/22/13 Pacific Standard Time
        try:
            message2apu = "APU ROGER"    
            queue2messages.put(message2apu)             
            print("(STEP 10A/70) OF TEST_QUEUE4XI - PUT TO QUEUE TEXT MESSAGE ",  message2apu)
            # APU ROGER
            message2bpu = "BPU ROGER"    
            queue2messages.put(message2bpu)             
            print("(STEP 10B/70) OF TEST_QUEUE4XI - PUT TO QUEUE TEXT MESSAGE ",  message2bpu)
            # BPU ROGER
            message2cpu = "CPU ROGER"    
            queue2messages.put(message2cpu)             
            print("(STEP 10C/70) OF TEST_QUEUE4XI - PUT TO QUEUE TEXT MESSAGE ",  message2cpu)
            # CPU ROGER
            message2dpu = "DPU ROGER"    
            queue2messages.put(message2dpu)             
            print("(STEP 10D/70) OF TEST_QUEUE4XI - PUT TO QUEUE TEXT MESSAGE ",  message2dpu)
            # DPU ROGER
            message2epu = "EPU ROGER"    
            queue2messages.put(message2epu)             
            print("(STEP 10E/70) OF TEST_QUEUE4XI - PUT TO QUEUE TEXT MESSAGE ",  message2epu)
            # EPU ROGER
            message2fpu = "FPU ROGER"    
            queue2messages.put(message2fpu)             
            print("(STEP 10F/70) OF TEST_QUEUE4XI - PUT TO QUEUE TEXT MESSAGE ",  message2fpu)
            # FPU ROGER
            message2gpu = "GPU ROGER"    
            queue2messages.put(message2gpu)             
            print("(STEP 10G/70) OF TEST_QUEUE4XI - PUT TO QUEUE TEXT MESSAGE ",  message2gpu)
            # GPU ROGER                                                                               
        except:
            print("(STEP 10Z/70) OF TEST_QUEUE4XI *** FAILED TO PUT TEXT MESSAGES TO QUEUE ", time4xi()) 
                     
            
        # -----------------------------------------------------------------------------------------
        # QUEUE STATISTICS - OK 
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 10C/70) OF TEST_QUEUE4XI - QUEUE STATISTICS ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time
        try:
            print("(STEP 10D/70) OF TEST_QUEUE4XI - QUEUE SIZE: ", queue2messages.qsize())
            # 2147483646
            print("(STEP 10E/70) OF TEST_QUEUE4XI - QUEUE EMPTY: ", queue2messages.empty())
            # False
            print("(STEP 10F/70) OF TEST_QUEUE4XI - QUEUE FULL: ", queue2messages.full())
            # False
        except:    
            print("(STEP 10Z/70) OF TEST_QUEUE4XI *** FAILED IN QUEUE STATISTICS ", time4xi()) 
                                 
        # -----------------------------------------------------------------------------------------
        # GET TEXT MESSAGES FROM QUEUE - OK 
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 11/70) OF TEST_QUEUE4XI - TRYING TO GET TEXT MESSAGES FROM QUEUE  ", time4xi())   
        # 02:58:24 01/22/13 Pacific Standard Time
        try:
            response2apu = queue2messages.get()             
            print("(STEP 11A/70) OF TEST_QUEUE4XI - GOT TEXT MESSAGE ",  response2apu)
            # APU ROGER
            response2bpu = queue2messages.get()             
            print("(STEP 11B/70) OF TEST_QUEUE4XI - GOT TEXT MESSAGE ",  response2bpu)
            # BPU ROGER
            response2cpu = queue2messages.get()             
            print("(STEP 11C/70) OF TEST_QUEUE4XI - GOT TEXT MESSAGE ",  response2cpu)
            # CPU ROGER 
            response2dpu = queue2messages.get()             
            print("(STEP 11D/70) OF TEST_QUEUE4XI - GOT TEXT MESSAGE ",  response2dpu)
            # DPU ROGER 
            response2epu = queue2messages.get()             
            print("(STEP 11E/70) OF TEST_QUEUE4XI - GOT TEXT MESSAGE ",  response2epu)
            # EPU ROGER 
            response2fpu = queue2messages.get()             
            print("(STEP 11F/70) OF TEST_QUEUE4XI - GOT TEXT MESSAGE ",  response2fpu)
            # FPU ROGER 
            response2gpu = queue2messages.get()             
            print("(STEP 11G/70) OF TEST_QUEUE4XI - GOT TEXT MESSAGE ",  response2gpu)
            # GPU ROGER                                                   
        except:
            print("(STEP 11Z/70) OF TEST_QUEUE4XI *** FAILED TO GET TEXT MESSAGES FROM QUEUE  ", time4xi()) 
                           
            
        # -----------------------------------------------------------------------------------------
        # QUEUE STATISTICS - OK  
        # -----------------------------------------------------------------------------------------                          
        print("(STEP 11C/70) OF TEST_QUEUE4XI - QUEUE STATISTICS ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time
        try:
            print("(STEP 11D/70) OF TEST_QUEUE4XI - QUEUE SIZE: ", queue2messages.qsize())
            # 2147483646  
            print("(STEP 11E/70) OF TEST_QUEUE4XI - QUEUE EMPTY: ", queue2messages.empty())
            # True 
            print("(STEP 11F/70) OF TEST_QUEUE4XI - QUEUE FULL: ", queue2messages.full())
            # False
        except:    
            print("(STEP 11Z/70) OF TEST_QUEUE4XI *** FAILED IN QUEUE STATISTICS ", time4xi()) 
                                                                                                    
        # -----------------------------------------------------------------------------------------
        # SENSE - OK 
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 31A/70) OF TEST_QUEUE4XI - TRYING TO SENSE IT ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time            
        try:
            print("(STEP 31B/70) OF TEST_QUEUE4XI - SENSED ARENA4XI OBJECT: ", arena2xi.sense()) 
            # {'object': <arena4xi.Arena4Xi object at 0x0000000002A6D9B0>, 'inheritance-of-arena2xi': 'object-inheriting-by-arena2xi-of-Arena4Xi'}
            print("(STEP 31C/70) OF TEST_QUEUE4XI - SENSED QUEUE4XI OBJECT: ", queue2messages.sense()) 
            #             
        except:
            print("(STEP 32Z/70) OF TEST_QUEUE4XI *** FAILED TO SENSE ", time4xi())
    
        
        # -----------------------------------------------------------------------------------------
        # REASON - OK 
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 32A/70) OF TEST_QUEUE4XI - TRYING TO REASON ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time            
        try:
            print("(STEP 32B/70) OF TEST_QUEUE4XI - REASONED ARENA4XI OBJECT: ", arena2xi.reason()) 
            # {'object-reason-object4xi': <arena4xi.Arena4Xi object at 0x0000000002A6D9B0>}
            print("(STEP 32C/70) OF TEST_QUEUE4XI - REASONED QUEUE4XI OBJECT: ", queue2messages.reason()) 
            # {'object-reason-object4xi': <queue4xi.Queue4Xi object at 0x000000000378E160>}                
        except:
            print("(STEP 32Z/70) OF TEST_QUEUE4XI *** FAILED TO REASON ", time4xi())               

        
        # -----------------------------------------------------------------------------------------
        # ACE - OK 
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 33A/70) OF TEST_QUEUE4XI - TRYING TO ACE ", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time            
        try:
            print("(STEP 33B/70) OF TEST_QUEUE4XI - ACED ARENA4XI OBJECT: ", arena2xi.ace()) 
            # {'object8xi': <arena4xi.Arena4Xi object at 0x0000000002A6D9B0>}
            print("(STEP 33C/70) OF TEST_QUEUE4XI - ACED QUEUE4XI OBJECT: ", queue2messages.ace()) 
            # {'object8xi': <queue4xi.Queue4Xi object at 0x000000000378E160>}               
        except:
            print("(STEP 33Z/70) OF TEST_QUEUE4XI *** FAILED TO ACE ", time4xi())               
        
        # -----------------------------------------------------------------------------------------
        # COMPLETED 
        # ----------------------------------------------------------------------------------------- 
        print("(STEP 70A/70) OF TEST_QUEUE4XI - COMPLETED TESTING OF ARENA4XI OBJECT", time4xi()) 
        # 02:58:24 01/22/13 Pacific Standard Time 
    except:
        print("(STEP 70Z/70) OF TEST_QUEUE4XI *** FAILED TO TEST ARENA4XI OBJECT ", time4xi())  
    
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
   
         
#</function4xi>
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function to test queue4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def main():

    print('=' *33)
    print("(SENSING IT WITH YOURDRAGONXI!")  
    print('=' *33)
        
    test_queue4xi()
    
    print('=' *33)
    print("(SENSED IT WITH YOURDRAGONXI!")    
    print('=' *33) 
                          
#</function4xi>
 

         

# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_queue4xi.txt
#   sense-test-queue4xi.xml
#   reason-test-queue4xi.xml
#   ace-test-queue4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_queue4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
